SystemOrganization addCategory: #'IdealTrie-SP'!

Collection subclass: #TrieWithBitDict
	instanceVariableNames: 'hasValue value bitDict isRoot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IdealTrie-SP'!

!TrieWithBitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/17/2012 20:24'!
valuesDo: aBlock
	"iterate over  tries for which hasValue is true"

	| bitIndex num  tmp |
	num := 31.
	self bitDictionary bitMapAsBits "might want to change this to use bitWise ops instead of iterating"
		do: [ :bit | 
			num := num - 1.
			self hasValue & (self bitDictionary bitMap = 0)
				ifTrue: [ ^ aBlock value: self value ].
			self hasValue & (self bitDictionary bitMap ~= 0) & (bit = $1)
				ifTrue: [ 
					self bitDictionary values do: [:trie | trie valuesDo: aBlock].
					^ aBlock value: self value ].
			(self hasValue = false) & (self bitDictionary bitMap ~= 0) & (bit = $1)
				ifTrue: [ 
					self bitDictionary values do: [:trie | trie valuesDo: aBlock] ] ]! !

Object subclass: #BitDict
	instanceVariableNames: 'bitMap values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IdealTrie-SP'!

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/22/2012 14:30'!
add: anObjectKey
^self at: anObjectKey put: nil  ! !

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/30/2012 23:13'!
at: anObjectKey
	| bitIndex val subBitMap temp |
	bitIndex := anObjectKey hash.
	subBitMap := 0.
	(self bitMap bitAt: bitIndex) = 0
		ifTrue: [ ^ nil ]
		ifFalse: [ 
			1 to: bitIndex do: [ :i | 
				temp := bitMap bitAt: i.
				temp = 1
					ifTrue: [ subBitMap := subBitMap + (2 raisedTo: i - 1) ] ].
			val := self values at: (self countPopulationOf: subBitMap).
			^ val ]! !

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/23/2012 22:08'!
at: anObjectKey ifAbsent: aBlock



! !

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/30/2012 22:52'!
at: anObjectKey ifAbsentPut:  anObjectValue 



! !

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/30/2012 23:12'!
at: anObjectKey put: anObjectValue
	| hashIndex newBitMap valuesToTheRight newBitDict |
	hashIndex := self returnBitMapFromIndex: 4 toIndex: 1 fromBitMap: anObjectKey hash.	"grab first 4 btis from anObject Key"
	(self bitMap bitAt: hashIndex) = 0
		ifTrue: [ self valuesAdd: anObjectValue withIndex: hashIndex ]
		ifFalse: [ 
			"if the bit is flagged,
			check and see what's next to it,	
			if a bitdict is next to it, continue down the chain if not, 
			add one and continue down the chain"
			newBitMap := self returnBitMapFromIndex: 5 toIndex: 31 fromBitMap: anObjectKey hash.	"return newBitMap with the just checked 4 bits chopped off"
			valuesToTheRight := self
				countPopulationOf: (self returnBitMapFromIndex: hashIndex toIndex: 1 fromBitMap: self bitMap).	"grab corresponding value using popCount of anObjectKey to the right of the 4 bits"
			(self values at: valuesToTheRight + 1) class = BitDict
				ifTrue: [ (self values at: valuesToTheRight + 1) at: newBitMap put: anObjectValue ]
				ifFalse: [ 
					newBitDict := values at: valuesToTheRight + 1 put: BitDict new.
					newBitDict at: newBitMap put: anObjectValue ] ]! !

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/17/2012 20:17'!
bitMap
^bitMap! !

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/17/2012 20:16'!
bitMap: smallInt
bitMap := smallInt! !

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/17/2012 20:16'!
countPopulationOf: n
	| SK5 SK3 SKF0 SKFF bitSet |
	SK5 := 16r15555555.
	SK3 := 16r33333333.
	SKF0 := 16rF0F0F0F.
	SKFF := 16rFF00FF.
	bitSet := n - (n >> 1 bitAnd: SK5).
	bitSet := (bitSet bitAnd: SK3) + (bitSet >> 2 bitAnd: SK3).
	bitSet := (bitSet bitAnd: SKF0) + (bitSet >> 4 bitAnd: SKF0).
	bitSet := bitSet + (bitSet >> 8).
	^ bitSet + (bitSet >> 16) bitAnd: 16r3F! !

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/22/2012 14:22'!
flagBit: bitIndex
	self bitMap bitAt: bitIndex put: 1! !

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/30/2012 23:12'!
includesKey: anObjectKey
	| bitIndex val subBitMap temp |
	bitIndex := anObjectKey hash.
	subBitMap := 0.
	(self bitMap bitAt: bitIndex) = 0
		ifTrue: [ ^ false ]
		ifFalse: [ ^ true ]! !

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/17/2012 20:13'!
initialize
	bitMap := 0.
	values := OrderedCollection new! !

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/22/2012 14:43'!
returnBitMapFromIndex: bitIndex toIndex: smallerBitIndex fromBitMap: aBitMap
	^(2 raisedTo: bitIndex - 1) - 1 bitAnd: aBitMap.! !

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/17/2012 20:12'!
size
	^ self countPopulationOf: bitMap! !

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/17/2012 20:12'!
values
^values! !

!BitDict methodsFor: 'as yet unclassified' stamp: 'StephaniePeterson 5/30/2012 22:54'!
valuesAdd: anObject withIndex: bitIndex
	| count |
	count := self values size.
	(self bitMap bitAt: bitIndex) = 0
		ifTrue: [ 
			self flagBit: bitIndex.
			count := self countPopulationOf: (self returnBitMapFromIndex: bitIndex toIndex: 1 fromBitMap: self bitMap).
			^ self values add: anObject afterIndex: count ]
		ifFalse: [ 
			count := self countPopulationOf: (self returnBitMapFromIndex: bitIndex toIndex: 1 fromBitMap: self bitMap).
			count = 0
				ifTrue: [ ^ self values add: anObject beforeIndex: 1 ]
				ifFalse: [ ^ self values add: anObject afterIndex: count ] ]! !
